#include "extcode.h"
#pragma pack(push)
#pragma pack(1)

#ifdef __cplusplus
extern "C" {
#endif
typedef struct {
	uint32_t netAddress;
	uint16_t port;
	LVRefNum connectionID;
	} TD1;

typedef struct {
	LVBoolean status;
	int32_t code;
	LStrHandle source;
	} TD2;

typedef struct {
	int32_t dimSize;
	LStrHandle dataOut[1];
	} TD3;
typedef TD3 **TD3Hdl;

typedef struct {
	uint32_t netAddress;
	uint16_t portRead;
	uint16_t portSend;
	LVRefNum connectionID;
	} TD4;

typedef struct {
	int32_t CANHandle;
	int32_t SendID;
	int32_t ReceiveID;
	int32_t ErrorID;
	} TD5;


void __cdecl initFTSensor(char IP[], TD1 *ConnectionData, TD2 *errorIn, 
	TD2 *errorOut);
void __cdecl readFTSensor(TD1 *ConnectionDataIn, TD3Hdl *FTSensorDataHeader, 
	double Forces[], int32_t *ForcesLength, double Torques[], 
	int32_t *TorquesLength, TD2 *errorIn, TD2 *errorOut);
void __cdecl closeFTSensor(TD1 *ConnectionDataIn, TD2 *errorIn, 
	TD2 *errorOut);
void __cdecl biasFTSensor(TD1 *ConnectionDataIn, TD2 *errorIn, TD2 *errorOut);
void __cdecl initOlimex(char IP[], TD4 *ConnectionData, TD2 *errorIn, 
	TD2 *errorOut);
void __cdecl readOlimex(TD4 *ConnectionDataIn, int32_t MainOlimex[], 
	int32_t *MainOlimexLength, int32_t ServoOlimex[], int32_t *ServoOlimexLength, 
	TD2 *errorIn, TD2 *errorOut);
void __cdecl writeOlimex(TD4 *ConnectionDataIn, int32_t ComputerOlimex[], 
	int32_t ComputerOlimexLength, TD2 *errorIn, TD2 *errorOut);
void __cdecl closeOlimex(TD4 *ConnectionDataIn, TD2 *errorIn, TD2 *errorOut);
void __cdecl closeGripper(TD5 *ConnectionDataIn, TD2 *errorIn, TD2 *errorOut);
void __cdecl gripGripper(TD5 *ConnectionDataIn, float Current, 
	float MaxVelocity, TD2 *errorIn, TD2 *errorOut);
void __cdecl initGripper(int32_t CANNetID, TD5 *ConnectionData, TD2 *errorIn, 
	TD2 *errorOut);
void __cdecl movposGripper(TD5 *ConnectionDataIn, float Position, 
	float Velocity, float Acceleration, float Jerk, float MaxCurrent, 
	TD2 *errorIn, TD2 *errorOut);
void __cdecl readGripper(TD5 *ConnectionDataIn, int32_t *CANIdentifier, 
	uint8_t *MessageLength, uint8_t DataByteArray[], int32_t DBALength, 
	char CMSGs[], int32_t CMSGsLength, TD2 *errorIn, TD2 *errorOut);
void __cdecl writeGripper(TD5 *ConnectionDataIn, uint8_t MessageLength, 
	uint8_t DataByteArray[], int32_t DBALength, TD2 *errorIn, TD2 *errorOut);

long __cdecl LVDLLStatus(char *errStr, int errStrLen, void *module);

#ifdef __cplusplus
} // extern "C"
#endif

#pragma pack(pop)

